;
; Request : MPLAB IDE v7.52 or higher
;===================================  

			list		p=16f887		; list directive to define processor
			#include	<p16f887.inc>	; processor specific variable definitions
	
;=================================== DATA MEMORY	
			extern	InitLCD
			extern	putcLCD
			extern	clrLCD
			extern	L1homeLCD
			extern	L2homeLCD
			extern  SendCmd
			extern	PutHexLCD
			extern	Hex2ASCII

;-----------------------------------
; USER DEFINED VARIABLES
;-----------------------------------
		
VARIABLES   	UDATA   0x030           ; start placing variables at this location
Tmp_WREG    	RES 1                   ; temporary storage for W register
Tmp_STATUS  	RES 1                   ; temporary storage for STATUS register
Tmp_PCLATH		RES 1                   ; temporary storage for PCLATH register
Table_Index		RES 1
Table_Buffer 	RES 1
S_Hold_Delay    RES 1

;=================================== PROGRAM MEMORY
			
;-----------------------------------
; VECTORS
;-----------------------------------

RESET_V     CODE    0x0000          ; reset vector
    		goto    Main                    ; jump to start of program


INT_V       CODE    0x0004          ; interrupt vector

;   No interupts expected, put in retfie in case of unexpected interrupt
    
    		retfie


;-----------------------------------
; MAIN PROGRAM LOOP
;-----------------------------------

            CODE    0x0040          ; force code to start on page 0            
Main
;===================================  System Clock Setting
;   Set the system clock at 4MHz using Hi-Frequency Internal RC
;   Set the OSCCON<IRCF2:IRCF0> for 4MHz selection
;   Internal RC Oscillator (INTOSC) is used for the system clock
	
			banksel OSCCON
			movlw	b'01100001'				; <ICRF2:ICRF0> = 110, <SCS> bit = 1 for INTOSC
			movwf	OSCCON
			nop
			btfss	OSCCON,HTS				; Check the HFINTOSC ststus?
			goto	$-2						; HFINTRC is not stable. Check again.
;		
			call	InitLCD
			call	Send_String1
			call	L2homeLCD
			call	Send_String2
;
Loop		goto	Loop
;	 	
;----------------------------------------------
;
Send_String1						;lookup table for display string on terminal
			clrf	Table_Index
Get_Next	movf	Table_Index,W
			call	String_Table_1
			movwf	Table_Buffer
			sublw	0x00
			btfsc	STATUS,Z
			goto	$+6
			movf	Table_Buffer,W
			call	putcLCD
			incf	Table_Index,F
			goto	Get_Next
			goto	S_Hold_Time

String_Table_1
			addwf	PCL,F
			dt      "Lab11-LCD Module"
			dt		0x00
;
Send_String2						;lookup table for display string on terminal
			clrf	Table_Index
Get_Next_1	movf	Table_Index,W
			call	String_Table_2
			movwf	Table_Buffer
			sublw	0x00
			btfsc	STATUS,Z
			goto	$+6
			movf	Table_Buffer,W
			call	putcLCD
			incf	Table_Index,F
			goto	Get_Next_1
			goto	S_Hold_Time

String_Table_2
			addwf	PCL,F
			dt		"LCD routine well"
			dt		0x00
;-----------------------------------
S_Hold_Time:
;***********************************************************************
;****		Sample Hold (Charge) time delay routine (50uS) 
;***********************************************************************
   			movlw	.255
   			movwf	S_Hold_Delay
			nop
   			decfsz	S_Hold_Delay,F
   			goto	$-2
   			return

			END              ; directive telling MPASM that code is done	
	
	
;*******************************************************************************;
;                 CODE OWNERSHIP AND DISCLAIMER OF LIABILITY                    ;
;                                                                               ;
; Microchip Technology Incorporated ("Microchip") retains all ownership and     ;
; intellectual property rights in the code accompanying this message and in all ;
; derivatives hereto.  You may use this code, and any derivatives created by    ;
; any person or entity by or on your behalf, exclusively with Microchips       ;
; proprietary products.  Your acceptance and/or use of this code constitutes    ;
; agreement to the terms and conditions of this notice.                         ;
;                                                                               ;
; CODE ACCOMPANYING THIS MESSAGE IS SUPPLIED BY MICROCHIP "AS IS". NO           ;
; WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED ;
; TO, IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A ;
; PARTICULAR PURPOSE APPLY TO THIS CODE, ITS INTERACTION WITH MICROCHIPS       ;
; PRODUCTS,COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.      ;
;                                                                               ;
; YOU ACKNOWLEDGE AND AGREE THAT, IN NO EVENT, SHALL MICROCHIP BE LIABLE,       ;
; WHETHER IN CONTRACT, WARRANTY, TORT (INCLUDING NEGLIGENCE OR BREACH OF        ;
; STATUTORY DUTY), STRICT LIABILITY, INDEMNITY,CONTRIBUTION, OR OTHERWISE, FOR  ;
; ANY INDIRECT, SPECIAL, PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS, ;
; DAMAGE, FOR COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE CODE,       ;
; HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR    ;
; THE DAMAGES ARE FORESEEABLE.  TO THE FULLEST EXTENT ALLOWABLE BY LAW,         ;
; MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED; TO THIS CODE,   ;
; SHALL NOT EXCEED THE PRICE YOU PAID DIRECTLY TO MICROCHIP SPECIFICALLY TO     ;
; HAVE THIS CODE DEVELOPED.                                                     ;
;                                                                               ;
; You agree that you are solely responsible for testing the code and            ;
; determining its suitability.  Microchip has no obligation to modify, test,    ;
; certify, or support the code.                                                 ;
;*******************************************************************************;
