;*******************************************************************************;
;   Microchip Technology Inc   2006
;
;   ASP 201     LAB 4
;   PWM lab
;   v2.0 revised 10/5/2006 by Stu Chandler, Sr.TTE
;	
;   This lab uses the CCP in PWM mode to emit a tone out of the buzzer on the 
;   APP001 evaluation board.  The buzzer is connected to the CCP1 pin on
;   PORTC<RC2>.
;
;   To emit the sound, the PWM should be set to a period of (Fosc/4)*255 with
;   a duty cycle of 50% (About 3.8KHz tone).  To achieve these values PR2 needs to be set to 255
;   and CCPR1L ( duty cycle) needs to be 80.  The code to load these SFRs is provided.
;
;   The following code must be completed
;
;   1) configure the CCP1 pin as an output  
;   2) start Timer 2 with Fosc/4 clock soure and a 1:1 pre-scaler
;   3) configure the CCP to act as a PWM 
;
;   The locations of the code to be added by the student are marked by comments 
;   containing ### Your Code Here ###
;
;*******************************************************************************;
; Request : MPLAB IDE v7.52 or higher
;===================================  

			list		p=16f887		; list directive to define processor
			#include	<p16f887.inc>	; processor specific variable definitions	
;=================================== DATA MEMORY	

;-----------------------------------
; USER DEFINED VARIABLES
;-----------------------------------
		
VARIABLES   UDATA   0x030           ; start placing variables at this location

Tmp_WREG    RES 1                   ; temporary storage for W register
Tmp_STATUS  RES 1                   ; temporary storage for STATUS register
Tmp_PCLATH	RES 1                   ; temporary storage for PCLATH register
Count		res 1				    ; variable used to count interrupts

#define		LEDs	PORTD

;=================================== PROGRAM MEMORY
			
;-----------------------------------
; VECTORS
;-----------------------------------

RESET_V     CODE    0x0000          ; reset vector
    goto    Main                    ; jump to start of program


INT_V       CODE    0x0004          ; interrupt vector

;   No interupts expected, put in retfie in case of unexpected interrupt
    
    retfie


;-----------------------------------
; MAIN PROGRAM LOOP
;-----------------------------------

            CODE    0x0040          ; force code to start on page 0            
Main
;===================================  System Clock Setting
;   Set the system clock at 4MHz using Hi-Frequency Internal RC
;   Set the OSCCON<IRCF2:IRCF0> for 4MHz selection
;   Internal RC Oscillator (INTOSC) is used for the system clock
	
	banksel OSCCON
	movlw	b'01100001'				; <ICRF2:ICRF0> = 110, <SCS> bit = 1 for INTOSC
	movwf	OSCCON
	nop
	btfss	OSCCON,HTS				; Check the HFINTOSC ststus?
	goto	$-2						; HFINTRC is not stable. Check again.
;		
    banksel PR2              		; point to BANK1
    movlw   0xFF                    ; establish PWM period
    movwf   PR2                     

; ### config CCP1 pin PORTC<RC2> as output pin

    Banksel	0		                ; point to BANK0
    movlw   0x80                    ; establish PWM duty cycle @ 50%
    movwf   CCPR1L                  

;-----------------------------------
;   Put CCP1 module in PWM mode,  Configure CCP to clear DCB1 and DCB0 ( no Q cycles)

; ### 
; ###

;-----------------------------------			 
;	Configure TMR2 with  pre and post scale of 1:1, then turn on TMR2
		
; ### turn on TMR2

;-----------------------------------

Loop
    nop
    goto    Loop

	
;-----------------------------------

	END                             ; directive telling MPASM that code is done	
	
	
;*******************************************************************************;
;                 CODE OWNERSHIP AND DISCLAIMER OF LIABILITY                    ;
;                                                                               ;
; Microchip Technology Incorporated ("Microchip") retains all ownership and     ;
; intellectual property rights in the code accompanying this message and in all ;
; derivatives hereto.  You may use this code, and any derivatives created by    ;
; any person or entity by or on your behalf, exclusively with Microchips       ;
; proprietary products.  Your acceptance and/or use of this code constitutes    ;
; agreement to the terms and conditions of this notice.                         ;
;                                                                               ;
; CODE ACCOMPANYING THIS MESSAGE IS SUPPLIED BY MICROCHIP "AS IS". NO           ;
; WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED ;
; TO, IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A ;
; PARTICULAR PURPOSE APPLY TO THIS CODE, ITS INTERACTION WITH MICROCHIPS       ;
; PRODUCTS,COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.      ;
;                                                                               ;
; YOU ACKNOWLEDGE AND AGREE THAT, IN NO EVENT, SHALL MICROCHIP BE LIABLE,       ;
; WHETHER IN CONTRACT, WARRANTY, TORT (INCLUDING NEGLIGENCE OR BREACH OF        ;
; STATUTORY DUTY), STRICT LIABILITY, INDEMNITY,CONTRIBUTION, OR OTHERWISE, FOR  ;
; ANY INDIRECT, SPECIAL, PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS, ;
; DAMAGE, FOR COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE CODE,       ;
; HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR    ;
; THE DAMAGES ARE FORESEEABLE.  TO THE FULLEST EXTENT ALLOWABLE BY LAW,         ;
; MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED; TO THIS CODE,   ;
; SHALL NOT EXCEED THE PRICE YOU PAID DIRECTLY TO MICROCHIP SPECIFICALLY TO     ;
; HAVE THIS CODE DEVELOPED.                                                     ;
;                                                                               ;
; You agree that you are solely responsible for testing the code and            ;
; determining its suitability.  Microchip has no obligation to modify, test,    ;
; certify, or support the code.                                                 ;
;*******************************************************************************;
