;********************************************************************************;
;
;   Filename:           16F887_configs.asm
;   Date:               10/3/2006
;   File Version:       0005
; 
;   Author:             Stu Chandler, TTE
;   Company:            Microchip Technology, Inc.
;   Build Tool:         MPASM
;
;   Target Processor:   PIC16F887              
;   Modify for APP001 EVM board 4/13'2007 by Richard Yang, Pr.CAE
;    
;********************************************************************************;

		list		p=16f887		; list directive to define processor
		#include	<p16f887.inc>	; processor specific variable definitions

;=================================== Define data into the EEPROM
DEEPROM	CODE
    	de    	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07
		de		0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f    	      	
    
;=================================== ID LOCATION ASSIGNMENT

    	__IDLOCS    0x12E5     	      	
    
;=================================== CONFIGURATION BIT ASSIGMENTS

;   The definitions and variants for the configuration bits are found in the
;   appropriage p16f887.inc
 
          
        __CONFIG _CONFIG1,  _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _MCLRE_ON & _CP_OFF & _CPD_OFF & _BOR_ON & _IESO_OFF & _FCMEN_OFF & _LVP_OFF & _DEBUG_ON ;
        __CONFIG _CONFIG2,  _WRT_OFF & _BOR40V;
   
       
    	END                                            
   
        
;*******************************************************************************;
;                 CODE OWNERSHIP AND DISCLAIMER OF LIABILITY                    ;
;                                                                               ;
; Microchip Technology Incorporated ("Microchip") retains all ownership and     ;
; intellectual property rights in the code accompanying this message and in all ;
; derivatives hereto.  You may use this code, and any derivatives created by    ;
; any person or entity by or on your behalf, exclusively with Microchips       ;
; proprietary products.  Your acceptance and/or use of this code constitutes    ;
; agreement to the terms and conditions of this notice.                         ;
;                                                                               ;
; CODE ACCOMPANYING THIS MESSAGE IS SUPPLIED BY MICROCHIP "AS IS". NO           ;
; WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED ;
; TO, IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A ;
; PARTICULAR PURPOSE APPLY TO THIS CODE, ITS INTERACTION WITH MICROCHIPS       ;
; PRODUCTS,COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.      ;
;                                                                               ;
; YOU ACKNOWLEDGE AND AGREE THAT, IN NO EVENT, SHALL MICROCHIP BE LIABLE,       ;
; WHETHER IN CONTRACT, WARRANTY, TORT (INCLUDING NEGLIGENCE OR BREACH OF        ;
; STATUTORY DUTY), STRICT LIABILITY, INDEMNITY,CONTRIBUTION, OR OTHERWISE, FOR  ;
; ANY INDIRECT, SPECIAL, PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS, ;
; DAMAGE, FOR COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE CODE,       ;
; HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR    ;
; THE DAMAGES ARE FORESEEABLE.  TO THE FULLEST EXTENT ALLOWABLE BY LAW,         ;
; MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED; TO THIS CODE,   ;
; SHALL NOT EXCEED THE PRICE YOU PAID DIRECTLY TO MICROCHIP SPECIFICALLY TO     ;
; HAVE THIS CODE DEVELOPED.                                                     ;
;                                                                               ;
; You agree that you are solely responsible for testing the code and determining;
; its suitability.  Microchip has no obligation to modify, test, certify, or    ;
; support the code.                                                             ;
;*******************************************************************************;
